

/* Config fuer die CPU280 mit 1Mbyte Speicher */


/* Remake devio.c when this is changed */
#ifdef DEVIO

extern wd_open(), wd_read(),wd_write();
extern fd_open(), fd_read(),fd_write();
extern tty_open(), tty_close(), tty_read(),tty_write(), tty_ioctl();
extern lpr_open(), lpr_close(), lpr_write();
extern kmem_read(),kmem_write();
extern mt_read(), mt_write(), mt_open(), mt_close();
extern null_write();


static struct devsw dev_tab[] =  /* The device driver switch table */
{
    { 0, wd_open, ok,       wd_read, wd_write, nogood },
    { 0, fd_open, ok,       fd_read, fd_write, nogood },	/* floppy */
    { 1, wd_open, ok,       wd_read, wd_write, nogood },
    { 2, wd_open, ok,       wd_read, wd_write, nogood },   /* Swap */
    { 0, lpr_open, lpr_close, nogood, lpr_write, nogood},     /* printer */
    { 0, tty_open, tty_close, tty_read, tty_write, tty_ioctl },  /* /dev/tty */
    { 1, tty_open, tty_close, tty_read, tty_write, tty_ioctl },  /* tty1 */
    { 2, tty_open, tty_close, tty_read, tty_write, tty_ioctl },  /* tty2 */
    { 0, ok, ok, ok, null_write, nogood },		      /* /dev/null */
    { 0, ok, ok, kmem_read, kmem_write, nogood },	      /* /dev/kmem */
    { 0, mt_open, mt_close, mt_read, mt_write, nogood }
};

#endif

#define NDEVS   4    /* Devices 0..NDEVS-1 are capable of being mounted */
#define TTYDEV  6    /* Device used by kernel for messages, panics */
		     /* Also initial process controlling tty */
#define SWAPDEV  3   /* Device for swapping. */
#define NBUFS  5     /* Number of block buffers */


#ifdef MACHDEP

struct pg_descr pgtab[] = {
	0x800a, 0, 0,
	0x801a, 0, 0,
	0x802a, 0, 0,
	0x803a, 0, 0,
	0x804a, 0, 0,
	0x805a, 0, 0,
	0x806a, 0, 0,
	0x807a, 0, 0,
	0x808a, 0, 0,
	0x809a, 0, 0,
	0x80aa, 0, 0,
	0x80ba, 0, 0,
	0x80ca, 0, 0,
	0x80da, 0, 0,
	0x80ea, 0, 0,
        0x80fa, 0, 0,
        0x820a, 0, 0,   
	0x821a, 0, 0,
	0x822a, 0, 0,
	0x823a, 0, 0,
	0x824a, 0, 0,
	0x825a, 0, 0,
	0x826a, 0, 0,
	0x827a, 0, 0,
	0x828a, 0, 0,
	0x829a, 0, 0,
	0x82aa, 0, 0,
	0x82ba, 0, 0,
	0x82ca, 0, 0,
	0x82da, 0, 0,
	0x82ea, 0, 0,
	0x82fa, 0, 0,
	0x830a, 0, 0,
	0x831a, 0, 0,
	0x832a, 0, 0,
	0x833a, 0, 0,
	0x834a, 0, 0,
	0x835a, 0, 0,
	0x836a, 0, 0,
	0x837a, 0, 0,
	0x838a, 0, 0,
	0x839a, 0, 0,
	0x83aa, 0, 0,
	0x83ba, 0, 0,
	0x83ca, 0, 0,
	0x83da, 0, 0,
	0x83ea, 0, 0,
	0x83fa, 0, 0,
	0x840a, 0, 0,
	0x841a, 0, 0,
	0x842a, 0, 0,
	0x843a, 0, 0,
	0x844a, 0, 0,
	0x845a, 0, 0,
	0x846a, 0, 0,
	0x847a, 0, 0,
	0x848a, 0, 0,
	0x849a, 0, 0,
	0x84aa, 0, 0,
	0x84ba, 0, 0,
	0x84ca, 0, 0,
	0x84da, 0, 0,
	0x84ea, 0, 0,
	0x84fa, 0, 0,
	0x850a, 0, 0,
	0x851a, 0, 0,
	0x852a, 0, 0,
	0x853a, 0, 0,
	0x854a, 0, 0,
	0x855a, 0, 0,
	0x856a, 0, 0,
	0x857a, 0, 0,
	0x858a, 0, 0,
	0x859a, 0, 0,
	0x85aa, 0, 0,
	0x85ba, 0, 0,
	0x85ca, 0, 0,
	0x85da, 0, 0,
	0x85ea, 0, 0,
	0x85fa, 0, 0,
	0x860a, 0, 0,
	0x861a, 0, 0,
	0x862a, 0, 0,
	0x863a, 0, 0,
	0x864a, 0, 0,
	0x865a, 0, 0,
	0x866a, 0, 0,
	0x867a, 0, 0,
	0x868a, 0, 0,
	0x869a, 0, 0,
	0x86aa, 0, 0,
	0x86ba, 0, 0,
	0x86ca, 0, 0,
	0x86da, 0, 0,
	0x86ea, 0, 0,
	0x86fa, 0, 0,
	0x870a, 0, 0,
	0x871a, 0, 0,
	0x872a, 0, 0,
	0x873a, 0, 0,
	0x874a, 0, 0,
	0x875a, 0, 0,
	0x876a, 0, 0,
	0x877a, 0, 0,
	0x878a, 0, 0,
	0x879a, 0, 0,
	0x87aa, 0, 0,
	0x87ba, 0, 0,
	0x87ca, 0, 0,
	0x87da, 0, 0,
	0x87ea, 0, 0,
	0x87fa, 0, 0,
	0x880a, 0, 0,
	0x881a, 0, 0,
	0x882a, 0, 0,
	0x883a, 0, 0,
	0x884a, 0, 0,
	0x885a, 0, 0,
	0x886a, 0, 0,
	0x887a, 0, 0,
	0x888a, 0, 0,
	0x889a, 0, 0,
	0x88aa, 0, 0,
	0x88ba, 0, 0,
	0x88ca, 0, 0,
	0x88da, 0, 0,
	0x88ea, 0, 0,
	0x88fa, 0, 0,
	0x890a, 0, 0,
	0x891a, 0, 0,
	0x892a, 0, 0,
	0x893a, 0, 0,
	0x894a, 0, 0,
	0x895a, 0, 0,
	0x896a, 0, 0,
	0x897a, 0, 0,
	0x898a, 0, 0,
	0x899a, 0, 0,
	0x89aa, 0, 0,
	0x89ba, 0, 0,
	0x89ca, 0, 0,
	0x89da, 0, 0,
	0x89ea, 0, 0,
	0x89fa, 0, 0,
	0x8a0a, 0, 0,
	0x8a1a, 0, 0,
	0x8a2a, 0, 0,
	0x8a3a, 0, 0,
	0x8a4a, 0, 0,
	0x8a5a, 0, 0,
	0x8a6a, 0, 0,
	0x8a7a, 0, 0,
	0x8a8a, 0, 0,
	0x8a9a, 0, 0,
	0x8aaa, 0, 0,
	0x8aba, 0, 0,
	0x8aca, 0, 0,
	0x8ada, 0, 0,
	0x8aea, 0, 0,
	0x8afa, 0, 0,
	0x8b0a, 0, 0,
	0x8b1a, 0, 0,
	0x8b2a, 0, 0,
	0x8b3a, 0, 0,
	0x8b4a, 0, 0,
	0x8b5a, 0, 0,
	0x8b6a, 0, 0,
	0x8b7a, 0, 0,
	0x8b8a, 0, 0,
	0x8b9a, 0, 0,
	0x8baa, 0, 0,
	0x8bba, 0, 0,
	0x8bca, 0, 0,
	0x8bda, 0, 0,
	0x8bea, 0, 0,
	0x8bfa, 0, 0,
	0x8c0a, 0, 0,
	0x8c1a, 0, 0,
	0x8c2a, 0, 0,
	0x8c3a, 0, 0,
	0x8c4a, 0, 0,
	0x8c5a, 0, 0,
	0x8c6a, 0, 0,
	0x8c7a, 0, 0,
	0x8c8a, 0, 0,
	0x8c9a, 0, 0,
	0x8caa, 0, 0,
	0x8cba, 0, 0,
	0x8cca, 0, 0,
	0x8cda, 0, 0,
	0x8cea, 0, 0,
	0x8cfa, 0, 0,
	0x8d0a, 0, 0,
	0x8d1a, 0, 0,
	0x8d2a, 0, 0,
	0x8d3a, 0, 0,
	0x8d4a, 0, 0,
	0x8d5a, 0, 0,
	0x8d6a, 0, 0,
	0x8d7a, 0, 0,
	0x8d8a, 0, 0,
	0x8d9a, 0, 0,
	0x8daa, 0, 0,
	0x8dba, 0, 0,
	0x8dca, 0, 0,
	0x8dda, 0, 0,
	0x8dea, 0, 0,
	0x8dfa, 0, 0,
	0x8e0a, 0, 0,
	0x8e1a, 0, 0,
	0x8e2a, 0, 0,
	0x8e3a, 0, 0,
	0x8e4a, 0, 0,
	0x8e5a, 0, 0,
	0x8e6a, 0, 0,
	0x8e7a, 0, 0,
	0x8e8a, 0, 0,
	0x8e9a, 0, 0,
	0x8eaa, 0, 0,
	0x8eba, 0, 0,
	0x8eca, 0, 0,
	0x8eda, 0, 0,
	0x8eea, 0, 0,
	0x8efa, 0, 0,
	0x8f0a, 0, 0,
	0x8f1a, 0, 0,
	0x8f2a, 0, 0,
	0x8f3a, 0, 0,
	0x8f4a, 0, 0,
	0x8f5a, 0, 0,
	0x8f6a, 0, 0,
	0x8f7a, 0, 0,
	0x8f8a, 0, 0,
	0x8f9a, 0, 0,
	0x8faa, 0, 0,
	0x8fba, 0, 0,
	0x8fca, 0, 0,
	0x8fda, 0, 0,
	0x8fea, 0, 0,
	0x8ffa, 0, 0
};

int npages = sizeof(pgtab) / sizeof(struct pg_descr);


#endif
